class_name MyNode
extends Node


class Data:
	var value
	pass


func _ready() -> void:
	var typed_array := create_array()


func create_array() -> Array[Data]:
	var untyped_array := [Data.new()]
	var data := untyped_array[0] as Data
	# Fails with error:
	# Trying to return an array of type "Array[RefCounted]" where expected return type is "Array[Data]".
	#return Array(untyped_array, TYPE_OBJECT, StringName(data.get_class()), null)
	
	# Even weirder: 
	# Trying to return an array of type "Array[Data]" where expected return type is "Array[Data]".
	#return Array(untyped_array, TYPE_OBJECT, "Data", null)
	
	# Also fails:
	# Trying to return an array of type "Array[MyNode.Data]" where expected return type is "Array[Data]".
	#return Array(untyped_array, TYPE_OBJECT, "MyNode.Data", null)
	
	var typed_array : Array[Data] = []
	for val in untyped_array:
		typed_array.push_back(val)
		
	# This prints "RefCounted" which is weird because type hints actually work and suggest `value`
	# when accessing an element of this array.
	print(typed_array.get_typed_class_name())
	return typed_array
